Subject: Re: [PATCH] powerpc:Fix rheap alignment problem

From: Pantelis Antoniou <[email-masked]>
Date: Sat, 1 Jul 2006 17:50:03 +0300

On Saturday 01 July 2006 17:34, Kumar Gala wrote:
> 
> On Jul 1, 2006, at 5:25 AM, Christoph Hellwig wrote:
> 
> > On Sat, Jul 01, 2006 at 05:21:06PM +1000, Benjamin Herrenschmidt  
> > wrote:
> >> On Sat, 2006-07-01 at 14:35 +0800, Linux powerpc wrote:
> >>> Yes, it was used for allocating dual port RAM for CPM.  And now  
> >>> we are
> >>> adding QE support to powerpc arch which need to use rheap(QE is next
> >>> generation for CPM).  Please see the patches I <[email-masked]>
> >>> just posted for 8360epb support.  Moreover, previous CPM support is
> >>> adding to powerpc arch too.
> >>
> >> Ok, well, I don't have anything specifically against that code, I was
> >> just wondering if it may not duplicate something we already have (yet
> >> another space allocator basically)...
> >
> > Yepp.  Without looking at the rheap allocator in deatail, any reason
> > it can't use lib/genalloc.c?
> 
> Doing a quick glance at lib/genalloc.c I dont see any reason we  
> couldn't use it.  However, Panto will know best, since he wrote rheap.
> 
> - k
> 

Hi there,

RHEAP started life long before on 2.4 before genalloc was included in the kernel.
The difference is only in the implementation, rheap uses double linked lists
while genalloc uses per pool bitmaps. RHEAP is faster & conserves a bit more space 
since it doesn't use a bitmap to track the chunks.

Since genalloc is the blessed linux thing it might be best to use that & remove
rheap completely. Oh well...

Regards

Pantelis